"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Database = exports.NodeWebSocket = void 0;
const WebSocket = require("ws");
class NodeWebSocket {
    constructor(url) {
        this.ws = new WebSocket(url);
    }
    onopen(callback) {
        this.ws.on("open", callback);
    }
    onmessage(callback) {
        this.ws.on("message", (data) => {
            if (data instanceof ArrayBuffer) {
                data = new TextDecoder().decode(data);
            }
            else if (data instanceof Buffer) {
                data = data.toString("utf-8");
            }
            else if (Array.isArray(data)) {
                data = Buffer.concat(data).toString("utf-8");
            }
            else if (typeof data !== "string") {
                throw new Error("Unknown data encoding");
            }
            callback(data);
        });
    }
    onclose(callback) {
        this.ws.on("close", callback);
    }
    onerror(callback) {
        this.ws.on("error", callback);
    }
    send(data) {
        this.ws.send(data);
    }
    close() {
        this.ws.close();
    }
}
exports.NodeWebSocket = NodeWebSocket;
const database_1 = require("./database");
exports.Database = database_1.default;
database_1.WebSocketConnector.WS = NodeWebSocket;
exports.default = database_1.default;
__exportStar(require("./index"), exports);
//# sourceMappingURL=node.js.map